unit uprimi;
interface
uses crt;
const maxfatt = 100;
var fatt: array[1..maxfatt] of cardinal;
    num: cardinal;
    ind, j: integer;
    maxcardinal : cardinal;
    
function bit(n : cardinal; i : integer): byte;
function modulexp(i, n, m: cardinal): cardinal;
procedure swap(var x, y: cardinal);
function DueElevatoA(e: byte) : cardinal;
function MCD(a, b: cardinal): cardinal;
function pseudoprimo(n: cardinal): boolean;
function MillerRa(n: cardinal; s: integer): boolean;
function PollRho(n: cardinal): boolean;

implementation

procedure swap(var x, y: cardinal);
var t: cardinal;
begin
     t:= x; x:= y; y:= t;
end;

function MCD(a, b: cardinal): cardinal;
var r: cardinal;
begin
     a:= abs(a); b:= abs(b);
     if a < b then swap(a,b);
     while b <> 0 do
     begin
          r:= a - b*(a div b);
          a:= b;
          b:= r;
     end;
     MCD:= a;
end;

function DueElevatoA(e: byte) : cardinal;
begin
	if e>31 then begin 
		writeln('Errore'); {la massima potenza di 2 che
			si puo' scrivere su 32 bit e' 2^31}
		DueElevatoA:=-1;
		end	
	else 
		DueElevatoA :=1 shl e
end;

function bit(n : cardinal; i : integer): byte;
var mask : cardinal;
begin
	mask := 1 shl i;  {   00000 .. 1 0000 }
			   {              ^ i zeri }
	bit:= (n and mask) shr i;

end;
		
function modulexp(i, n, m: cardinal): cardinal;
var d : cardinal;
    j : integer;
    ris : cardinal;
begin
	d:=i mod m;
	ris:=1;
	for j:=0 to 31 do begin
		if bit(n,j)=1 then
			ris:=ris*d mod m;
		d:=(d*d) mod m;
		end;
	modulexp:=ris;
end;

function MillerRa(n: cardinal; s: integer): boolean;
var j: integer;
    a: cardinal;

   m: boolean;

function Witness(a,n: cardinal): boolean;
var d, i, x: cardinal;
begin
     Witness:= false; d:=1;
     for i:= 31 downto 0 do
     begin
          x:= d;
          d:= d*d mod n;
          if (d=1) and (x<>1) and (x <> n-1) then Witness:= true;
          if bit(n-1, i) = 1 then d:= d*a mod n
     end;
     if (d<>1) then Witness:= true;
end;

begin
     M:= false;
     for j:= 1 to s do
     begin
          a:= random(n-2) + 1; { numero compreso tra 1 e n-1 compresi }
          if witness(a, n)
             then M:= True;
     end;
     MillerRa:=M;
end;

function PollRho(n: cardinal): boolean;
var x, y, k, i, d: cardinal;
    trovato: boolean;

procedure InsFatt(x: cardinal);
begin
     j:= 1;
     while (fatt[j] <> x) and (j < ind) do j:= j+1;
     if j = ind then begin fatt[j]:= x; ind:= ind+1; trovato:= true end;
end;

begin
   Trovato:= false;
   ind:= 1;
   i:= 1;
   x:= random(n-1);
   y:= x;
   k:= 2;
   while i < trunc(sqrt(sqrt(n))) do
   begin
        i:= i+1;
        x:= (sqr(x) - 1) mod n;
        d:= MCD(y - x, n);
        if (d<>1) and (d<>n) then InsFatt(d);
        if i=k then begin y:= x; k:= 2*k end;
   end;
   PollRho:= trovato;
end;

function pseudoprimo(n: cardinal): boolean;
begin
   pseudoprimo:= modulexp(2,n-1,n) <> 1;
end;

begin
    MaxCardinal:=1 shl 32;
end.
