unit uprimi;
interface
uses crt;
const maxfatt = 100;
var fatt: array[1..maxfatt] of longint;
    num: longint;
    ind, j: integer;

function bit(n : longint; i : integer): byte;
function modulexp(i, n, m: longint): longint;
procedure swap(var x, y: longint);
function DueElevatoA(e: byte) : longint;
function MCD(a, b: longint): longint;
function pseudoprimo(n: longint): boolean;
function MillerRa(n: longint; s: integer): boolean;
function PollRho(n: longint): boolean;

implementation

procedure swap(var x, y: longint);
var t: longint;
begin
     t:= x; x:= y; y:= t;
end;

function MCD(a, b: longint): longint;
var r: longint;
begin
     a:= abs(a); b:= abs(b);
     if a < b then swap(a,b);
     while b <> 0 do
     begin
          r:= a - b*(a div b);
          a:= b;
          b:= r;
     end;
     MCD:= a;
end;

function DueElevatoA(e: byte) : longint;
begin
	if e>30 then begin 
		writeln('Errore'); {la massima potenza di 2 che
			si pu scrivere su 32 bit con il segno  2^30}
		DueElevatoA:=-1;
		end	
	else 
		DueElevatoA :=1 shl e
end;

function bit(n : longint; i : integer): byte;
var mask : longint;
begin
	mask := 1 shl i;  {   00000 .. 1 0000 }
			   {              ^ i zeri }
	bit:= (n and mask) shr i;

end;

function quadr(d,n:longint):longint;
(* restituisce d*d mod n *)
const rad=Trunc(sqrt(MaxLongInt));
var times,ris,r,q : longint;
   (*  dd: double; *)
begin
	if d<rad then 
		quadr:=d*d mod n
	else begin
		times:=d; ris:=0;
                r:=d mod n; q:=d div n;
		while (times>0) do begin
			ris:=(ris+r) mod n;
			times:=times-(q+1);
			end;
		quadr:=ris;
		end;
end;


function moltipl(a,b,n : longint):longint;
(* restituisce a*b mod n.  *)
var ris : longint;
begin
	if (MaxLongInt div b)>a then 
		ris:=a*b mod n
	else begin
	        (* Pongo in b il minore tra a e b *)
	        if a<b then swap(a,b);
        	ris:=0;
		while (b>0) do begin
			ris:=(ris+a) mod n;
			b:=b-1;
			end;

		end;
	moltipl:=ris;
end;
			

function modulexp(i, n, m: longint): longint;
var d : longint;
    j : integer;
    ris : longint;
begin
	d:=i mod m;
	ris:=1;
	for j:=0 to 31 do begin
		if bit(n,j)=1 then
			ris:=ris*d mod m;
		d:=quadr(d,m);
		end;
	modulexp:=ris;
end;

function MillerRa(n: longint; s: integer): boolean;
var j: integer;
    a: longint;

   m: boolean;

function Witness(a,n: longint): boolean;
var d, i, x: longint;
begin
     Witness:= false; d:=1;
     for i:= 31 downto 0 do
     begin
          x:= d;
          d:= quadr(d,n);
          if (d=1) and (x<>1) and (x <> n-1) then Witness:= true;
          if bit(n-1, i) = 1 then d:= d*a mod n
     end;
     if (d<>1) then Witness:= true;
end;

begin
     M:= false;
     for j:= 1 to s do
     begin
          a:= random(n-2) + 1; { numero compreso tra 1 e n-1 compresi }
          if witness(a, n)
             then M:= True;
     end;
     MillerRa:=M;
end;

function PollRho(n: longint): boolean;
var x, y, k, i, d: longint;
    trovato: boolean;

procedure InsFatt(x: longint);
begin
     j:= 1;
     while (fatt[j] <> x) and (j < ind) do j:= j+1;
     if j = ind then begin fatt[j]:= x; ind:= ind+1; trovato:= true end;
end;

begin
   Trovato:= false;
   ind:= 1;
   i:= 1;
   x:= random(n-1);
   y:= x;
   k:= 2;
   while i < trunc(sqrt(sqrt(n))) do
   begin
        i:= i+1;
        x:= (sqr(x) - 1) mod n;
        d:= MCD(y - x, n);
        if (d<>1) and (d<>n) then InsFatt(d);
        if i=k then begin y:= x; k:= 2*k end;
   end;
   PollRho:= trovato;
end;

function pseudoprimo(n: longint): boolean;
begin
   pseudoprimo:= modulexp(2,n-1,n) <> 1;
end;

end.
