Unit UMPrimi;
Interface
uses crt, Mathe;
Const MaxFatt = 50;
var fatt: array[1..MaxFatt] of RecNo;

Function pseudoprimo(n: RecNo): boolean;
Function MillerRa(n: RecNo; s: integer): boolean;
Function PollRho(n: RecNo; var ind: integer): boolean;

Implementation

Function pseudoprimo(n: RecNo): boolean;
var Uno, Due, Ps, NMU: RecNo;

Procedure modulexp(i, n, m: RecNo; var F: RecNo);
var d, Ris : RecNo;
    j : integer;
    Bin: BinNo;
    Fitt: RecNo;
begin
	DivNo(i,m,fitt,d);
        InitNo(F);
        TrasfBin(n, Bin);
        Let(Ris, Uno);
	for j:=1 to BinCfr do begin
		if Bin[j]=1 then
                begin
                    {DivNo(d, m, fitt, app);}
                    MulNo(Ris,d, Ris);
                    DivNo(Ris, m, fitt, Ris);
                end;
		DivNo(d, m, fitt, d);
                MulNo(d,d, d);
		end;
	Let(F, Ris);
end;

begin
{ PseudoPrimo:= modulexp(2, n-1, n) <> 1 }
   AssegnaNo(Uno, '1');
   AssegnaNo(Due, '2');
   Dif(N, Uno, NMU);
   ModulExp(Due, NMU, N, Ps);
   PseudoPrimo:= not  EqNo(Ps, Uno);
end;


Function MillerRa(n: RecNo; s: integer): boolean;
var Uno, Due, Nm2, a: RecNo;
    k: integer;

Function Witness(a, n: RecNo): boolean;
var d,NMU, x, Fitt: RecNo;
    BinN: BinNo;
    i, Ds: integer;
begin
   WitNess:= false; AssegnaNo(d, '1');
   Dif(n,Uno,NMU);
   TrasfBin(NMU, BinN);
   Ds:= CalcCBin(BinN);
   for i:= Ds downto 1 do
   begin
      Let(x, d);
      MulNo(d,d,d);
      DivNo(d,n,Fitt,d);
      if (EqNo(d,Uno)) and (not EqNo(x, Uno)) and (not EqNo(x,NMU)) then
         WitNess:= true;
      if BinN[i] = 1 then
      begin
         MulNo(d,a,d);
         DivNo(d,n,Fitt, d);
      end;
   end;
   if (not EqNo(d,Uno)) then WitNess:= true;
end;

begin
    MillerRa:= False;
    AssegnaNo(uno, '1');
    AssegnaNo(Due, '2');
    Dif(n,Due, Nm2);
    for k:= 1 to s do
    begin
       RandomNo(Nm2, a);
       IncrUnoNo(a);
       if WitNess(a,n)
          then MillerRa:= True;
    end;
end;


Function PollRho(n: RecNo; var ind: integer): boolean;
var Trovato: boolean;
    Cnd, k, d: RecNo;
    Uno, Due, NMU, RQP, Fitt, x, y: RecNo;

Procedure InsFatt(x: RecNo);
var j: integer;
begin
   j:= 1;
   while (not EqNo(Fatt[j], x)) and (j<ind) do j:= j + 1;
   if j = ind then
   begin
      Let(Fatt[j], x);
      Inc(ind);
      Trovato:= True;
   end;
end;

begin
   Trovato:= false;
   ind:= 1;
   AssegnaNo(Uno, '1'); Dif(n, Uno, NMU);
   Let(Cnd, Uno);
   RandomNo(NMU, x);
   Let(y, x);
   Sum(Uno,Uno, Due);
   Let(k, Due);
   RadQuadr(n, RQP);
   RadQuadr(RQP, RQP);
   IncrUnoNo(RQP);
   while Less(Cnd, RQP) do
   begin
      IncrUnoNo(Cnd);
      MulNo(x,x,x);
      Dif(x,Uno,x);
      DivNo(x,n,Fitt,x);
      Dif(y,x,Fitt);
      MCDNo(Fitt,n,d);
      if (not EqNo(d, Uno)) and (not EqNo(d,n)) then
         InsFatt(d);
      if (EqNo(Cnd,k)) then
      begin Let(y,x); MulNo(k,Due,k) end;
   end;
   PollRho:= trovato;
end;

end.
