unit Mathe;
Interface
uses crt;
const NoCfr = 18;
      BinCfr = (Trunc(NoCfr*3.322)) + 1;
type RecNo = array [1..NoCfr] of byte;
     BinNo = array [1..BinCfr] of byte;
     StrNo = string[NoCfr];

Function CalcCfr(Num: RecNo): byte;
Function CalcCBin(Num: BinNo): byte;
Procedure InitNo(var NoInit: RecNo);
Procedure WriteNo(NoWrite: RecNo);
Procedure ReadNo(var NoRead: RecNo);
Procedure Let(var A : RecNo; const B:RecNo);
Function EqNo(A, B: RecNo): boolean;
Procedure AssegnaNo(var No: RecNo; V: string);
Procedure SwapNo(var A,B: RecNo);
Procedure Sum(A, B: RecNo; var Ris: RecNo);
Function Dif(A, B: RecNo; var Ris: RecNo): boolean;
Function Greater(const A,B : RecNo) : boolean;
Function Less(const A,B : RecNo) : boolean;
Procedure IncrUnoNo(var A: RecNo);
Function DivDue(A: RecNo; var B: RecNo): byte;
Procedure TrasfBin(A: RecNo; var B: BinNo);
Procedure ShlBinNo(var B: BinNo; l: integer);
Procedure MulNo(A,B: RecNo; var Ris: RecNo);
Procedure RandNo(var R: RecNo);
Procedure RandomNo(Int: RecNo; var R: RecNo);
{Procedure DueAlla(var Ris: BinNo; Esp: integer);}
Procedure MCDNo(A,B: RecNo; var MinC: RecNo);
Procedure DivNo(A,B : RecNo; var Q: RecNo; var R:RecNo);
Procedure RadQuadr(x:RecNo; var R:RecNo);

Implementation

Function CalcCfr(Num: RecNo): byte;
var i: integer;
begin
   i:= NoCfr;
   while (Num[i] = 0) and (i>1) do i:=i-1;
   if i = 1 then if Num[i] = 0 then i:= 0;
   CalcCfr:= i;
end;

Function CalcCBin(Num: BinNo): byte;
var i: integer;
begin
   i:= BinCfr;
   while (Num[i] = 0) and (i>1) do i:=i-1;
   if i = 1 then if Num[i] = 0 then i:= 0;
   CalcCBin:= i;
end;

Procedure InitNo(var NoInit: RecNo);
var i: integer;
begin
   for i:= 1 to NoCfr do NoInit[i]:= 0;
end;

Procedure WriteNo(NoWrite: RecNo);
var i, cf: integer;
begin
   cf:= CalcCfr(NoWrite);
   if cf = 0 then Write('0')
   else for i:= Cf downto 1 do Write(NoWrite[i]);
end;

Procedure ReadNo(var NoRead: RecNo);
var Str: StrNo;
    i, Ctrl, Err, len: integer;
begin
     Readln(Str);
     if Str = '' then ReadNo(NoRead);
     InitNo(NoRead);
     len:= length(Str);
     for i:=len downto 1 do
     begin
        Val(Str[i], Ctrl, Err);
        if Err <> 0 then
        begin
           Write('Valore non numerico');
           exit;
        end;
        NoRead[len-i+1]:= Ctrl;
     end;
end;

Procedure Sum(A, B: RecNo; var Ris: RecNo);
var i: integer;
    Rip: boolean;
    parz: integer;
begin
   Rip:= false;
   for i:= 1 to NoCfr do
   begin
      parz:= A[i] + B[i];
      if Rip then Inc(parz);
      Rip:= (parz>9);
      parz:= parz mod 10;
      Ris[i]:= parz;
   end;
   if Rip then Write('Overflow sulla somma');
end;

Function Dif(A, B: RecNo; var Ris: RecNo): boolean;
{Restituisce true se A < B}
var i : integer;
    Rip : boolean;
    parz: integer;
begin
   Rip:= false;
   for i:= 1 to NoCfr do
   begin
	parz:=A[i]-B[i];
	if Rip then parz:=parz-1;
	Rip:=false;
	if parz <0 then
        begin
           parz:=parz+10;
           Rip:=true
        end;
	Ris[i]:=parz;
    end;
    Dif:=Rip;
end;

Function Greater(const A,B : RecNo) : boolean;
var R: RecNo;
begin
	Greater:=Dif(B,A,R);
end;

Function Less(const A,B : RecNo) : boolean;
var R : RecNo;
begin
	Less:=Dif(A,B,R);
end;

Procedure Let(var A : RecNo; const B:RecNo);
var i: integer;
begin
	for i:=1 to NoCfr do A[i]:=B[i];
end;

Function EqNo(A, B: RecNo): boolean;
var i: integer;
    Eq: boolean;
begin
   Eq:= True;
   i:= 1;
   while  (A[i] = B[i]) and (i<=NoCfr) do i:= i + 1;
   {for i:=1 to NoCfr do if A[i] <> B[i] then Eq:= false;}
   EqNo:= (i>NoCfr);
end;

Procedure IncrUnoNo(var A: RecNo);
var Rip: boolean;
    i: integer;
begin
   i:= 1;
   repeat
      Rip:= (A[i]+1) > 9;
      A[i]:= (A[i]+1) mod 10;
      Inc(i);
   until (not Rip) or (i>NoCfr);
   if Rip then Write('Problemi di overflow');
end;

Function DivDue(A: RecNo; var B: RecNo): byte;
var Rip: boolean;
    i, Parz: integer;
begin
   InitNo(B);
   Rip:= false;
   for i:= CalcCfr(A) downto 1 do
   begin
      If Rip then Parz:= A[i] + 10
             else Parz:= A[i];
      B[i]:= Parz div 2;
      Rip:= (Parz mod 2) <> 0;
   end;
   if Rip then DivDue:= 1 else DivDue:= 0;
end;

Procedure TrasfBin(A: RecNo; var B: BinNo);
var i: integer;
begin
   for i:= 1 to BinCfr do B[i]:= 0;
   i:= 1;
   repeat
      B[i]:= DivDue(A,A);
      i:=i+1;
   until CalcCfr(A)=0;
end;

Procedure ShiftNo(var Num: RecNo; Left: integer);
var k, cf: integer;
begin
   if Left <> 0 then
   begin
      cf:= CalcCfr(Num);
      if (cf + Left) > NoCfr then Write('Overflow di moltiplicazione')
      else for k:= cf downto 1 do
           begin
              Num[k+Left]:= Num[k];
              Num[k]:= 0;
           end;
   end;
end;

Procedure MulNo(A,B: RecNo; var Ris: RecNo);
var i: integer;
    Parz: RecNo;

Procedure MulP(A: RecNo; Val: byte; var Pr: RecNo);
var count: integer;
begin
   InitNo(Pr);
   for count:=1 to Val do Sum(Pr, A, Pr);
end;

begin
   InitNo(Parz); InitNo(Ris);
   for i:= 1 to CalcCfr(B) do
   begin
      MulP(A, B[i], Parz);
      ShiftNo(Parz, i-1);
      Sum(Ris, Parz, Ris);
   end;
end;

Procedure RandNo(var R: RecNo);
var i: integer;
begin
   InitNo(R);
   for i:=((NoCfr div 2)-2) downto 1 do R[i]:= Random(10);
   R[i]:= R[i] + ((R[i]+1) mod 2);
end;

Procedure RandomNo(Int: RecNo; var R: RecNo);
var i, k: integer;
begin
   i:= CalcCfr(Int);
   InitNo(R);
   R[i]:= Random(Int[i] + 1);
   while (i>1) and (R[i]=Int[i]) do
   begin
      i:= i - 1;
      R[i]:= Random(Int[i] + 1);
   end;
   i:= i - 1;
   if i=0 then R[1]:= Random(Int[1])
   else for k:= i downto 1 do R[i]:= Random(10);
end;

Procedure ShlBinNo(var B: BinNo; l: integer);
var i: integer;
begin
   for i:= BinCfr downto (l+1) do B[i]:= B[i-l];
   for i:= l downto 1 do B[i]:= 0;
end;

{Procedure DueAlla(var Ris: BinNo; Esp: integer);
var i: integer;
begin
   if Esp < (BinCfr-1) then
   begin
      for i:= 1 to BinCfr do Ris[i]:= 0;
      Ris[esp+1]:= 1;
   end
   else write('Esponente troppo elevato');
end;}

Procedure AssegnaNo(var No: RecNo; V: string);
var len, Ctrl, Err, i: integer;
begin
     InitNo(No);
     len:= length(V);
     for i:=len downto 1 do
     begin
        Val(V[i], Ctrl, Err);
        if Err <> 0 then
        begin
           Write('Valore non numerico');
           exit;
        end;
        No[len-i+1]:= Ctrl;
     end;
end;

Procedure SwapNo(var A,B: RecNo);
var T: RecNo;
begin
   Let(T, A); Let(A, B); Let(B, T);
end;

Procedure DivNo(A,B : RecNo; var Q: RecNo; var R:RecNo);
var Temp, Res: RecNo;
    abb, ca, cb, i, N: integer;

Procedure Div10(F, S: RecNo; var I: integer; var Resto: RecNo);
var T: RecNo;
begin
    InitNo(Resto);
    i:= 0;
    Let(T, F);
    While (not Less(T, S)) do
    begin
       Dif(T, S, T);
       i:= i + 1;
    end;
    Let(Resto, T);
end;

begin
   InitNo(Q);
   if Less(B, A) then
   begin
      InitNo(Temp);
      Cb:= CalcCfr(B); Ca:= CalcCfr(A);
      for i:=1 to Cb do
         Temp[Cb-i+1]:= A[Ca-i+1];
      if Less(Temp, B) then
      begin
         ShiftNo(Temp, 1);
         Temp[1]:= A[Ca - i];
      end;
      Abb:= CalcCfr(Temp);
      Div10(Temp, B, N, Res);
      Q[ca-abb+1]:= N;
      for i:= ca-abb downto 1 do
      begin
         Let(Temp, Res);
         ShiftNo(Temp, 1);
         Temp[1]:= A[i];
         Div10(Temp, B, N, Res);
         Q[i]:= N;
      end;
      Let(R, Res);
   end
   else Let(R, A);
end;

Procedure MCDNo(A,B: RecNo; var MinC: RecNo);
var R, Fitt: RecNo;
begin
   if Less(A,B) then SwapNo(A,B);
   while CalcCfr(B) <> 0 do
   begin
      DivNo(A, B, R, Fitt);
      MulNo(R, B, R);
      Dif(A, R, R);
      Let(A, B); Let(B, R);
   end;
   Let(MinC, A);
end;

Procedure RadQuadr(x:RecNo; var R:RecNo);
var p,t,inut, Uno: RecNo;

begin
    InitNo(R);
    AssegnaNo(Uno,'1');
    if CalcCfr(x)<>0 then
    begin
     Let(R,X);
     repeat
           Let(p,r);
           {r:=(r+x/r)/2 }
           DivNo(x,r,t,inut);
	   Sum(t,r,t);
	   DivDue(t,r);
	   Dif(p,r,t);
     until not greater(t,uno);
     end;
end;

end.
